<template>
  <span
    :class="`icon icon-${name}`"
    :style="{ fontSize: computedFontSize, color: computedColor }"
    @click="handleClick"
  ></span>
</template>

<script lang="ts">
import Vue from "vue";
import ThemeDefaults from "@/components/theme/defaults";

export default Vue.extend({
  name: "BaseIcon",
  props: {
    name: {
      type: String,
      required: true
    },
    size: {
      type: String,
      required: false,
      default: "1"
    },
    color: {
      type: String,
      required: false,
      default: "black"
    }
  },
  computed: {
    computedFontSize: function() {
      return this.size + "rem";
    },
    computedColor: function() {
      return ThemeDefaults.pallete[this.color] || this.color;
    }
  },
  methods: {
    handleClick: function(e: EventTarget) {
      this.$emit("click", e);
    }
  }
});
</script>

<style>
/* import custom font icon */
@import url("./index.css");
</style>
